# -*- coding: utf-8 -*-
"""
Define la clase de ejemplo MiClase, con métodos estáticos,
de clase y de instancia

@author: Michael
@date:   Ene 2022
"""


class MiClase:
    """
    La clase de ejemplo MiClase, contiene métodos estáticos,
    de clase y de instancia
    """

    __c: str = "'soy estático'"

    def __init__(self, nombre):
        self.__nombre: str = nombre

    def metodo_de_instancia(self):
        # print(self.metodo_de_clase())
        # print(self.metodo_estatico())
        # print(MiClase.metodo_de_clase())
        # print(MiClase.metodo_estatico())
        return "En método de instancia de nombre " + \
            self.__nombre+" accede a "+self.__c

    @classmethod
    def metodo_de_clase(cls):
        # print(cls.metodo_estatico())
        # print(MiClase.metodo_estatico())
        return "En método de clase. Hay acceso a " + \
            cls.__c

    @staticmethod
    def metodo_estatico():
        return "En método estático. " + \
            "No se debe acceder a ningún atributo"


def ejemplos():
    obj = MiClase("Pepe")
    print(obj.metodo_de_instancia())
    print(obj.metodo_de_clase())
    print(obj.metodo_estatico())
